"use strict";

require("core-js/modules/es6.object.define-property.js");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.is-array.js");

require("core-js/modules/es6.array.some.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.date.to-string.js");

require("core-js/modules/es6.regexp.to-string.js");

require("core-js/modules/es6.array.map.js");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _api = require("../../../common/api");

var _tool = require("../../../common/tool");

/* eslint-disable consistent-return */

/* eslint-disable func-names */

/**
 * 异步选择组件
 */
var Option = _antd.Select.Option; // 封装组件

var AjaxSelect = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      listData = _useState4[0],
      setListData = _useState4[1];

  (0, _react.useEffect)(function () {
    handleGetList();
  }, []);

  var handleGetList = function handleGetList() {
    var apiName = props.apiName,
        apiData = props.apiData,
        apiMethod = props.apiMethod,
        listName = props.listName;
    setLoading(true);
    (0, _api.fetch)({
      apiName: apiName,
      apiData: apiData,
      apiMethod: apiMethod
    }).then(function (data) {
      setLoading(false);
      setListData(data.data);
    })["catch"](function (err) {
      _tool.log.error(err);

      _antd.message.error("\u83B7\u53D6".concat(listName, "\u5931\u8D25:").concat(err.message));
    });
  };

  var handleChange = function handleChange(key) {
    var value = props.value,
        listValueKey = props.listValueKey,
        listNameKey = props.listNameKey,
        onChange = props.onChange;

    if (Array.isArray(value)) {
      if (!key) return onChange(['', '']);
      var label;
      listData.some(function (item) {
        if (item[listValueKey].toString() === key) {
          label = item[listNameKey];
          return true;
        }

        return false;
      });
      onChange([key, label]);
    } else {
      onChange(key || '');
    }
  };

  var value = props.value,
      listName = props.listName,
      listValueKey = props.listValueKey,
      listNameKey = props.listNameKey,
      disabled = props.disabled;
  var selectValue;

  if (Array.isArray(value)) {
    // eslint-disable-next-line prefer-destructuring
    selectValue = value[0];
  } else {
    selectValue = value;
  }

  return /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
    spinning: loading,
    className: "app-ajax-select"
  }, /*#__PURE__*/_react["default"].createElement(_antd.Select, {
    showSearch: true,
    optionFilterProp: "children",
    value: selectValue,
    onChange: handleChange,
    placeholder: "\u9009\u62E9".concat(listName),
    notFoundContent: "\u672A\u627E\u5230".concat(listName),
    allowClear: true,
    disabled: disabled,
    ref: ref
  }, /*#__PURE__*/_react["default"].createElement(Option, {
    value: "",
    title: "\u9009\u62E9".concat(listName)
  }, "\u9009\u62E9", listName), listData.map(function (item, index) {
    return /*#__PURE__*/_react["default"].createElement(Option, {
      key: index,
      value: item[listValueKey].toString(),
      title: item[listNameKey]
    }, item[listNameKey]);
  })));
});
AjaxSelect.propTypes = {
  apiName: _propTypes["default"].string.isRequired,
  // API请求名,由于直接诶读取data.data的数组数据,所以该API不能使用分页
  apiData: _propTypes["default"].object,
  // api请求附加的数据
  apiMethod: _propTypes["default"].string,
  // api请求method
  listName: _propTypes["default"].string.isRequired,
  // 缺省列表名称
  listValueKey: _propTypes["default"].string.isRequired,
  // 列表值的key值
  listNameKey: _propTypes["default"].string.isRequired,
  // 列表名称key值
  value: _propTypes["default"].oneOfType([// 值,支持字符串和数组形式
  _propTypes["default"].string, // key值
  _propTypes["default"].array // [key, label]形式
  ]),
  onChange: _propTypes["default"].func,
  // 获取值变化函数
  disabled: _propTypes["default"].bool
};
var _default = AjaxSelect;
exports["default"] = _default;