"use strict";

require("core-js/modules/es6.object.define-property.js");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.function.bind.js");

require("core-js/modules/es6.regexp.match.js");

require("core-js/modules/es6.regexp.split.js");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _tool = require("../../../common/tool");

var _fetchJsonp = _interopRequireDefault(require("fetch-jsonp"));

var _configProvider = require("../config-provider");

function getUploadDownloadInfo(key, path) {
  var pathUrl = path;

  if (key) {
    pathUrl += (/\?/.test(path) ? '&' : '?') + (0, _tool.serialize)({
      key: key
    });
  }

  return (0, _fetchJsonp["default"])(pathUrl, {
    jsonpCallback: 'jsonpCallback'
  }).then(function (response) {
    return response.json();
  });
}

var RmsFilesDown = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RmsFilesDown, _Component);

  var _super = (0, _createSuper2["default"])(RmsFilesDown);

  function RmsFilesDown(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, RmsFilesDown);
    _this = _super.call(this, props);
    _this.state = {
      redirectUrl: '',
      loading: true
    };
    _this.open = true;
    _this.handleFetchDownUrl = _this.handleFetchDownUrl.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(RmsFilesDown, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps) {
      var url = this.props.url;

      if (url !== preProps.url) {
        this.handleFetchDownUrl();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.handleFetchDownUrl();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.open = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          redirectUrl = _this$state.redirectUrl,
          loading = _this$state.loading;
      var _this$props = this.props,
          content = _this$props.content,
          showTip = _this$props.showTip;
      return /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
        spinning: loading,
        tip: showTip || ''
      }, redirectUrl ? /*#__PURE__*/_react["default"].createElement("a", {
        href: redirectUrl,
        target: "__blank",
        download: true
      }, content) : null);
    }
  }, {
    key: "handleFetchDownUrl",
    value: function handleFetchDownUrl() {
      var _this2 = this;

      var _this$props2 = this.props,
          url = _this$props2.url,
          filename = _this$props2.filename;
      var uploadTokenURI = this.context.uploadTokenURI;
      var apiName = "".concat(uploadTokenURI, "/getDownloadParamJsonp");

      if (!url.match(/\?key=(.+)/)) {
        this.setState({
          loading: false,
          redirectUrl: url
        });
        return;
      }

      var decodeUrl = decodeURIComponent(url.match(/\?key=(.+)/)[1]);
      getUploadDownloadInfo(decodeUrl, apiName).then(function (data) {
        var file = data.data;
        var fileType = file.mimetype.split('/')[1];
        var downName = /\..+/.test(filename) ? filename : "".concat(filename, ".").concat(fileType); // 如果传入的filename已经包含后缀名

        if (_this2.open) {
          _this2.setState({
            loading: false,
            redirectUrl: file.mimetype.split('/')[0] === 'image' ? "".concat(file.downloadUrl, "?attname=").concat(encodeURIComponent(downName)) : file.downloadUrl
          });
        }
      })["catch"](function (err) {
        _this2.setState({
          loading: false
        });

        _antd.message.error("\u83B7\u53D6\u4E0B\u8F7D\u5730\u5740\u5931\u8D25:".concat(err.message));
      });
    }
  }]);
  return RmsFilesDown;
}(_react.Component);

RmsFilesDown.contextType = _configProvider.ConfigContext;
RmsFilesDown.propTypes = {
  url: _propTypes["default"].string.isRequired,
  // 文件地址
  content: _propTypes["default"].object.isRequired,
  filename: _propTypes["default"].string.isRequired,
  showTip: _propTypes["default"].string
}; /// / import RmsFilesDown from '../../../../src/components/basic/view/rms_files_down';

var _default = RmsFilesDown;
exports["default"] = _default;