"use strict";

require("core-js/modules/es6.object.define-property.js");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.function.bind.js");

require("core-js/modules/es6.array.slice.js");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _tool = require("../../../common/tool");

var _rule = _interopRequireDefault(require("../../../enums/rule"));

/**
 * 省市区级联组件
 */
// 封装组件
var AddressSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(AddressSelect, _Component);

  var _super = (0, _createSuper2["default"])(AddressSelect);

  function AddressSelect(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, AddressSelect);
    _this = _super.call(this, props);
    _this.selectChange = _this.selectChange.bind((0, _assertThisInitialized2["default"])(_this));
    _this.inputChange = _this.inputChange.bind((0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      options: [],
      level: props.level || 3,
      selectValue: props.value.slice(0, 3),
      initValue: props.value.slice(3)
    };
    return _this;
  } // 组件载入时


  (0, _createClass2["default"])(AddressSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var level = this.state.level;
      var data = (0, _tool.getCityTreeData)(level);
      this.setState({
        options: data
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          options = _this$state.options,
          level = _this$state.level,
          initValue = _this$state.initValue,
          selectValue = _this$state.selectValue;
      var input = initValue.join();
      var inputLength = input.length;
      var disabled = this.props.disabled;
      return /*#__PURE__*/_react["default"].createElement("div", null, level === 4 ? /*#__PURE__*/_react["default"].createElement(_antd.Row, {
        gutter: 8
      }, /*#__PURE__*/_react["default"].createElement(_antd.Col, {
        span: 12
      }, /*#__PURE__*/_react["default"].createElement(_antd.Cascader, {
        disabled: disabled,
        defaultValue: selectValue,
        options: options,
        onChange: this.selectChange,
        placeholder: "\u8BF7\u9009\u62E9"
      })), /*#__PURE__*/_react["default"].createElement(_antd.Col, {
        span: 12
      }, /*#__PURE__*/_react["default"].createElement(_antd.Input, {
        disabled: disabled,
        defaultValue: input,
        maxLength: _rule["default"].addressLength,
        onChange: this.inputChange,
        suffix: "".concat(inputLength, "/").concat(_rule["default"].addressLength)
      }))) : /*#__PURE__*/_react["default"].createElement(_antd.Cascader, {
        disabled: disabled,
        defaultValue: selectValue,
        options: options,
        onChange: this.selectChange,
        placeholder: "\u8BF7\u9009\u62E9"
      }));
    }
  }, {
    key: "selectChange",
    value: function selectChange(data) {
      var onChange = this.props.onChange;
      var initValue = this.state.initValue;
      this.setState({
        selectValue: data
      });
      onChange(data.concat(initValue));
    }
  }, {
    key: "inputChange",
    value: function inputChange(event) {
      var onChange = this.props.onChange;
      var selectValue = this.state.selectValue;
      var inputValue = event.target.value;
      var data = inputValue ? [inputValue] : [];
      this.setState({
        initValue: data
      });
      onChange(selectValue.concat(data));
    }
  }]);
  return AddressSelect;
}(_react.Component);

AddressSelect.propTypes = {
  level: _propTypes["default"].number,
  value: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  onChange: _propTypes["default"].func
};
var _default = AddressSelect;
exports["default"] = _default;