"use strict";

require("core-js/modules/es6.object.define-property.js");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.promise.js");

require("core-js/modules/es6.array.map.js");

require("core-js/modules/es6.array.for-each.js");

require("core-js/modules/es6.array.index-of.js");

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireWildcard(require("prop-types"));

var _antd = require("antd");

var _api = require("../../../common/api");

var _tool = require("../../../common/tool");

/* eslint-disable no-nested-ternary */

/* eslint-disable no-plusplus */

/* eslint-disable no-param-reassign */

/* eslint-disable no-unused-expressions */

/* eslint-disable no-underscore-dangle */

/* eslint-disable consistent-return */

/**
 * 异步省市区
 * 墨烦/秦国胜
 * 2021/07/14
 */
var SHOW_PARENT = _antd.TreeSelect.SHOW_PARENT,
    TreeNode = _antd.TreeSelect.TreeNode;

var AjaxTreeSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(AjaxTreeSelect, _Component);

  var _super = (0, _createSuper2["default"])(AjaxTreeSelect);

  function AjaxTreeSelect() {
    var _this;

    (0, _classCallCheck2["default"])(this, AjaxTreeSelect);
    _this = _super.call(this);

    _this.getTreeData = function () {
      var _this$props = _this.props,
          apiName = _this$props.apiName,
          apiData = _this$props.apiData,
          apiMethod = _this$props.apiMethod,
          treeName = _this$props.treeName;

      _this.setState({
        loading: true
      });

      (0, _api.fetch)({
        apiName: apiName,
        apiData: apiData,
        apiMethod: apiMethod
      }).then(function (data) {
        // 判断如果卸载,则不再设置数据
        if (!_this.open) return;

        _this.setState({
          loading: false,
          treeData: data.data
        });
      })["catch"](function (err) {
        _this.setState({
          loading: false
        });

        _tool.log.error(err);

        _antd.message.error("\u83B7\u53D6".concat(treeName, "\u5931\u8D25:").concat(err.message));
      });
    };

    _this.onLoadData = function (treeNode) {
      var _this$props2 = _this.props,
          apiName = _this$props2.apiName,
          apiParentParams = _this$props2.apiParentParams,
          apiParent = _this$props2.apiParent,
          apiParentVal = _this$props2.apiParentVal,
          apiMethod = _this$props2.apiMethod,
          treeChildren = _this$props2.treeChildren,
          treeValueKey = _this$props2.treeValueKey;
      var treeData = _this.state.treeData;
      var code = treeNode.props[apiParentVal || treeValueKey];
      return new Promise(function (resolve) {
        if (treeNode.props[treeChildren] && treeNode.props[treeChildren].length) {
          resolve();
          return;
        }

        var params = (0, _objectSpread2["default"])({}, apiParentParams);
        params[apiParent || treeValueKey] = code;
        (0, _api.fetch)({
          apiName: apiName,
          apiData: params,
          apiMethod: apiMethod
        }).then(function (res) {
          if (res && res.data && res.data.length) {
            var datas = res.data;

            var recursion = function recursion(list) {
              var len = list.length;

              for (var i = 0; i < len; i++) {
                if (list[i][treeChildren] && list[i][treeChildren].length) {
                  //    list[i].isLeaf = true;
                  recursion(list[i][treeChildren]);
                } else {//    list[i].isLeaf = false;
                }

                if (list[i][apiParentVal || treeValueKey] === code) {
                  list[i][treeChildren] = datas;
                  break;
                }
              }
            };

            recursion(treeData);
          }

          _this.setState({
            treeData: treeData
          });

          resolve();
        })["catch"](function (err) {
          // this.setState({
          //     loading: true
          // });
          _tool.log.error(err.message);
        });
      });
    };

    _this.renderTreeNodes = function (data) {
      var _this$props3 = _this.props,
          treeValueKey = _this$props3.treeValueKey,
          treeNameKey = _this$props3.treeNameKey,
          treeChildren = _this$props3.treeChildren;
      return data && data.length ? data.map(function (item) {
        if (item[treeChildren] && item[treeChildren].length) {
          return /*#__PURE__*/_react["default"].createElement(TreeNode, {
            key: item[treeValueKey],
            title: item[treeNameKey],
            value: item[treeValueKey]
          }, item[treeChildren] && item[treeChildren].length ? _this.renderTreeNodes(item[treeChildren]) : '');
        }

        return /*#__PURE__*/_react["default"].createElement(TreeNode, (0, _extends2["default"])({}, item, {
          key: item[treeValueKey],
          title: item[treeNameKey],
          value: item[treeValueKey]
        }));
      }) : '';
    };

    _this.onChange = function (val, label) {
      var _this$props4 = _this.props,
          onChange = _this$props4.onChange,
          multiple = _this$props4.multiple,
          treeValueKey = _this$props4.treeValueKey,
          treeNameKey = _this$props4.treeNameKey;
      var changeData = {}; // console.log('val', val);
      // console.log('label', label);

      if (multiple) {
        changeData = [];
        val.forEach(function (item, index) {
          var obj = {};
          obj[treeValueKey] = item;
          obj[treeNameKey] = label[index];
          changeData.push(obj);
        });
      } else {
        changeData[treeValueKey] = val;
        changeData[treeNameKey] = label[0] || '';
      }

      onChange && onChange(changeData);
    };

    _this.state = {
      loading: false,
      // loading
      treeData: [] // 数据

    }; // 是否已加载

    _this.open = true;
    return _this;
  }

  (0, _createClass2["default"])(AjaxTreeSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getTreeData();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.open = false;
    } // 获取数据

  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          loading = _this$state.loading,
          treeData = _this$state.treeData;
      var _this$props5 = this.props,
          showSearch = _this$props5.showSearch,
          allowClear = _this$props5.allowClear,
          value = _this$props5.value,
          multiple = _this$props5.multiple,
          isSelectParent = _this$props5.isSelectParent,
          isCheck = _this$props5.isCheck,
          treeName = _this$props5.treeName,
          showCheckedStrategy = _this$props5.showCheckedStrategy,
          treeValueKey = _this$props5.treeValueKey,
          disabled = _this$props5.disabled,
          maxTagCount = _this$props5.maxTagCount,
          isOnLoad = _this$props5.isOnLoad;
      var disposeValue = {};

      if (value) {
        if (multiple && value.length) {
          disposeValue = [];
          value.forEach(function (item) {
            disposeValue.push(item[treeValueKey]);
          });
        } else {
          disposeValue = value[treeValueKey] || undefined;
        }
      } // 多选处理


      var propsMultiple = isCheck ? {
        treeCheckable: true
      } : {
        multiple: multiple
      }; // 是否异步按需加载

      var propsOnLoad = isOnLoad ? {
        loadData: this.onLoadData
      } : {};
      return /*#__PURE__*/_react["default"].createElement(_antd.Spin, {
        spinning: loading
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: isSelectParent ? 'com-tree-select-no-parent' : ''
      }, /*#__PURE__*/_react["default"].createElement(_antd.TreeSelect, (0, _extends2["default"])({
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        },
        filterTreeNode: function filterTreeNode(input, option) {
          return option.props.title.toLowerCase().indexOf(input.toLowerCase()) >= 0;
        },
        showSearch: showSearch,
        allowClear: allowClear,
        disabled: disabled,
        showCheckedStrategy: showCheckedStrategy,
        value: disposeValue,
        placeholder: "\u9009\u62E9".concat(treeName),
        notFoundContent: "\u672A\u627E\u5230".concat(treeName),
        onChange: this.onChange,
        maxTagCount: maxTagCount
      }, propsMultiple, propsOnLoad), this.renderTreeNodes(treeData))));
    }
  }]);
  return AjaxTreeSelect;
}(_react.Component);

AjaxTreeSelect.defaultProps = {
  multiple: false,
  isCheck: false,
  isSelectParent: false,
  isOnLoad: false,
  showSearch: true,
  allowClear: true,
  disabled: false,
  apiData: {},
  // 请求参数
  apiParentParams: {},
  showCheckedStrategy: SHOW_PARENT,
  treeChildren: 'children'
};
AjaxTreeSelect.propTypes = {
  apiName: _propTypes["default"].string.isRequired,
  // API请求名,由于直接诶读取data.data的数组数据,所以该API不能使用分页
  apiData: _propTypes["default"].object,
  // 附加产参数
  apiMethod: _propTypes["default"].string,
  // api请求method
  treeName: _propTypes["default"].string.isRequired,
  // 缺省列表名称
  treeValueKey: _propTypes["default"].string.isRequired,
  // 树表值的key值
  treeNameKey: _propTypes["default"].string.isRequired,
  // 树表名称key值
  treeChildren: _propTypes["default"].string,
  // 树表的子级key值， 默认Children
  isOnLoad: _propTypes["default"].bool,
  // 是否异步加载
  apiParentParams: _propTypes["default"].object,
  // 异步加载父级参数
  apiParent: _propTypes["default"].string,
  // 异步加载父级查询参数字段
  apiParentVal: _propTypes["default"].string,
  // 异步加载父级查询，取值字段
  value: _propTypes["default"].oneOfType([// 传递的值
  _propTypes["default"].array, _propTypes["default"].object]),
  onChange: _propTypes["default"].func,
  // 值变化
  isSelectParent: _propTypes["default"].bool,
  // 是否父级可选
  multiple: _propTypes["default"].bool,
  // 是否多选,isNoParent为true,不选择父级
  isCheck: _propTypes["default"].bool,
  // CheckBocx多选, isNoParent为true无效
  showSearch: _propTypes["default"].bool,
  // 是否搜索
  allowClear: _propTypes["default"].bool,
  // 是否显示清除图标
  showCheckedStrategy: _propTypes.any,
  // 定义选中项回填的方式
  disabled: _propTypes["default"].bool,
  // 是否禁用
  maxTagCount: _propTypes["default"].number,
  // 最多显示多少tag
  dropdownStyle: _propTypes["default"].object // 下拉菜单的样式

};
var _default = AjaxTreeSelect;
exports["default"] = _default;