"use strict";

require("core-js/modules/es6.object.define-property.js");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _reactImages = _interopRequireWildcard(require("react-images"));

var ImgPreview = function ImgPreview(props) {
  var _props$images = props.images,
      images = _props$images === void 0 ? [] : _props$images,
      open = props.open,
      onClose = props.onClose;

  var _useState = (0, _react.useState)(open),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      modalIsOpen = _useState2[0],
      setModalIsOpen = _useState2[1];

  (0, _react.useEffect)(function () {
    setModalIsOpen(open);
  }, [images, open]);

  var toggleModal = function toggleModal() {
    setModalIsOpen(!modalIsOpen);

    if (typeof onClose === 'function') {
      onClose();
    }
  };

  var styleInit = {
    header: function header() {
      return {
        // 头部样式
        position: 'absolute',
        top: 10,
        right: 10,
        zIndex: 9999
      };
    },
    view: function view() {
      return {
        textAlign: 'center',
        maxHeight: '95vh',
        maxWidth: '95vw'
      };
    }
  };
  return /*#__PURE__*/_react["default"].createElement(_reactImages.ModalGateway, null, modalIsOpen ? /*#__PURE__*/_react["default"].createElement(_reactImages.Modal, {
    onClose: toggleModal
  }, /*#__PURE__*/_react["default"].createElement(_reactImages["default"], {
    views: images,
    styles: styleInit
  })) : null);
};

var _default = ImgPreview;
exports["default"] = _default;